#include "subject.h"

void Subject::attach(Person *person)
{
	mObservers.push_back(person);
	person->registerSubject(this);
}

void Subject::detach(Person *person)
{
	for(int i = 0; i < mObservers.size(); ++i)
	{
		if(person == mObservers[i])
		{
			mObservers.erase(mObservers.begin() + i);
		}
	}
}

void Subject::notify()
{
	for(int i = 0; i < mObservers.size(); ++i)
	{
		mObservers[i]->update(state());
	}
}
