#ifndef SUBJECT_H
#define SUBJECT_H

#include <vector>
#include <string>
#include <iostream>
#include "person.h"

using namespace std;

/*

Subject
Abstract class

*/

class Subject
{

	public:

		void attach(Person *person);
		void detach(Person *person);
		void notify();

		virtual string state() = 0;
		virtual void setState(string state) = 0;

	private:

		vector<Person*> mObservers;

};

#endif
